package ru.dbotthepony.mc.otm.worldgen.placement

import com.mojang.serialization.MapCodec
import net.minecraft.core.BlockPos
import net.minecraft.util.valueproviders.IntProvider
import ru.dbotthepony.mc.otm.worldgen.EnhancedPlacementContext

class EnhancedCountPlacement(val provider: IntProvider) : EnhancedPlacementModifier {
	override fun evaluate(context: EnhancedPlacementContext, positions: List<BlockPos>): List<BlockPos> {
		val count = provider.sample(context.random)

		if (count <= 0) {
			return listOf()
		} else if (count == 1) {
			return positions
		} else {
			val result = ArrayList<BlockPos>()
			result.ensureCapacity(positions.size * count)
			for (i in 0 until count) result.addAll(positions)
			return result
		}
	}

	override val type: EnhancedPlacementModifier.Type<*>
		get() = Companion

	companion object : EnhancedPlacementModifier.Type<EnhancedCountPlacement> {
		override val codec: MapCodec<EnhancedCountPlacement> = IntProvider.CODEC.xmap(::EnhancedCountPlacement, EnhancedCountPlacement::provider).fieldOf("count")
	}
}
